// MIT License

// Copyright (c) 2017 Vadim Grigoruk @nesbox // grigoruk@gmail.com

// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to deal
// in the Software without restriction, including without limitation the rights
// to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:

// The above copyright notice and this permission notice shall be included in all
// copies or substantial portions of the Software.

// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// SOFTWARE.

#pragma once

#include "studio/studio.h"

typedef struct Surf Surf;

struct Surf
{
    tic_mem* tic;
    struct tic_fs* fs;
    struct tic_net* net;
    struct Console* console;
    struct Movie* state;

    bool init;
    bool loading;
    s32 ticks;

    struct
    {
        s32 pos;
        s32 anim;
        s32 anim_target;
        struct MenuItem* items;
        s32 count;
    } menu;

    void(*tick)(Surf* surf);
    void(*resume)(Surf* surf);
    void (*scanline)(tic_mem* tic, s32 row, void* data);
    void (*overline)(tic_mem* tic, void* data);
};

void initSurf(Surf* surf, tic_mem* tic, struct Console* console);
void freeSurf(Surf* surf);
